 /*
  * Khoros: $Id$
  */

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for kprval
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: Apr 08, 1995
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _kprval_h_
#define _kprval_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <datamanip.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

#define PANEPATH "$DATAMANIP/objects/kroutine/kprval/uis/kprval.pane"
        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Input data object (required infile)
 */
char	*i_file;	/* Input data object FILENAME */
int	 i_flag;	/* Input data object FLAG */

/*----- required ME group ----*/
/*
 *  operate on value data (optional flag)
 */
int	 val_flag;  	/* operate on value data FLAG */

/*
 *  operate on map data (optional flag)
 */
int	 map_flag;  	/* operate on map data FLAG */

/*
 *  operate on mask data (optional flag)
 */
int	 mask_flag;  	/* operate on mask data FLAG */

/*
 *  operate on time data (optional flag)
 */
int	 time_flag;  	/* operate on time data FLAG */

	/*---- nested optional MI group ----*/
/*
 *  operate on location data (optional flag)
 */
int	 loc_flag;  	/* operate on location data FLAG */

/*
 *  offset of point along location dimension (optional integer)
 */
int	 dimoff_int; 	/* offset of point along location dimension INT */
int	 dimoff_flag;	/* offset of point along location dimension FLAG */

	/*-- nested optional MI group end --*/

/*-- required ME group end ---*/

/*
 *  map value data through the map before processing (optional logical)
 */
int	 mapdata_logic;	/* map value data through the map before processing LOGIC */
int	 mapdata_flag;  	/* map value data through the map before processing FLAG */

/*
 *  offset of point along width dimension (optional integer)
 */
int	 woff_int; 	/* offset of point along width dimension INT */
int	 woff_flag;	/* offset of point along width dimension FLAG */

/*
 *  offset of point along height dimension (optional integer)
 */
int	 hoff_int; 	/* offset of point along height dimension INT */
int	 hoff_flag;	/* offset of point along height dimension FLAG */

/*
 *  offset of point along depth dimension (optional integer)
 */
int	 doff_int; 	/* offset of point along depth dimension INT */
int	 doff_flag;	/* offset of point along depth dimension FLAG */

/*
 *  offset of point along time dimension (optional integer)
 */
int	 toff_int; 	/* offset of point along time dimension INT */
int	 toff_flag;	/* offset of point along time dimension FLAG */

/*
 *  offset of point along elements dimension (optional integer)
 */
int	 eoff_int; 	/* offset of point along elements dimension INT */
int	 eoff_flag;	/* offset of point along elements dimension FLAG */

/*
 *  Name of variable to which output value is assigned (optional string)
 */
char	*var_string;	/* Name of variable to which output value is assigned STRING */
int	 var_flag;   	/* Name of variable to which output value is assigned FLAG */

/*
 *  Output ASCII in which to append data value (optional outfile)
 */
char	*o_file;	/* Output ASCII in which to append data value FILENAME */
int	 o_flag;	/* Output ASCII in which to append data value FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

void main PROTO((int, char **, char **));
void kprval_get_args PROTO((kform *));
void kprval_usage_additions PROTO((void));
void kprval_free_args PROTO((int, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
