 /*
  * Khoros: $Id$
  */

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for gextents
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: Apr 13, 1995
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _gextents_h_
#define _gextents_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <geometry.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

#define PANEPATH "$GEOMETRY/objects/kroutine/gextents/uis/gextents.pane"
        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input data object (required infile)
 */
char	*i_file;	/* input data object FILENAME */
int	 i_flag;	/* input data object FLAG */

/*
 *  output geometry object (required outfile)
 */
char	*o_file;	/* output geometry object FILENAME */
int	 o_flag;	/* output geometry object FLAG */

/*
 * box color (Optional boolean toggle)
 *	1 (white box)
 *	2 (colored box),
 */
int	 color_toggle;		/* box color LOGICAL TOGGLE */
int	 color_flag;		/* box color FLAG */

/*
 * box type (Optional boolean toggle)
 *	1 (min/max 3D box)
 *	2 (shrink-wrap bounding hull),
 */
int	 type_toggle;		/* box type LOGICAL TOGGLE */
int	 type_flag;		/* box type FLAG */

/*
 *  object name (optional string)
 */
char	*name_string;	/* object name STRING */
int	 name_flag;   	/* object name FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

void main PROTO((int, char **, char **));
void gextents_get_args PROTO((kform *));
void gextents_usage_additions PROTO((void));
void gextents_free_args PROTO((int, kaddr));

/* -include_routines */
int make_extents_box PROTO((kobject, kobject, int, char *,int));
/* -include_routines_end */

#endif
